## Supported Modules

The following hardware modules are supported.

Module             | LCode | Description
-------------------|-------|-----------------------
01 Sonoff Basic    |       | Sonoff Basic Wifi Smart Switch
02 Sonoff RF       |       | Sonoff RF Wifi Smart Switch with RF (434MHz) receiver
03 Sonoff SV       |       | Sonoff SV Safe Voltage Wifi Smart Switch
04 Sonoff TH       |       | Sonoff TH10/TH16 Wifi Smart Switch with Sensor connection
05 Sonoff Dual     |   x   | Sonoff Dual Wifi Smart Switch
06 Sonoff Pow      |       | Sonoff Pow Wifi Smart Switch with Energy Monitoring
07 Sonoff 4CH      |       | Sonoff 4CH 4-gang Wifi Smart Switch
08 Sonoff S2X      |       | Sonoff S20/S26 Wifi Smart Socket
09 Slampher        |       | Sonoff Slampher Wifi Smart Light Bulb Socket with RF (434MHz) receiver
10 Sonoff Touch    |   x   | Sonoff Touch Wifi Light Switch
11 Sonoff LED      |   x   | Sonoff Led Wifi Led Pack (Retired)
12 1 Channel       |       | 1 Channel Inching/Self Locking Wifi Switch 5V/12V
13 4 Channel       |   x   | 4 Channel Inching/Self Locking Wifi Switch (Retired)
14 Motor C/AC      |   x   | Motor Clockwise/Antoclockwise Wifi Switch (Retired)
15 ElectroDragon   |       | Electrodragon Wifi IoT Board
16 EXS Relay(s)    |   x   | Electronic Experience Store 1 or 2-gang Wifi Module
17 WiOn            |       | WiOn Wifi Smart Socket
18 Generic         |   x   | Any ESP8266/ESP8285 device like WeMos and NodeMCU
19 Sonoff Dev      |       | Sonoff Dev Wifi Development Board
20 H801            |   x   | H801 Wifi 5 Channel LED Controller
21 Sonoff SC       |   x   | Sonoff SC Wifi Environmental Monitor
22 Sonoff BN-SZ    |   x   | Sonoff BN-SZ01 Wifi Ceiling Led (Retired)
23 Sonoff 4CH Pro  |   x   | Sonoff 4CH Pro 4-gang Wifi Smart Switch
24 Huafan SS       |       | HuaFan Wifi Smart Socket
25 Sonoff Bridge   |   x   | Sonoff RF (434MHz) transceive to Wifi Bridge
26 Sonoff B1       |   x   | Sonoff B1 Wifi RGBWW Led Bulb
27 AiLight         |   x   | Ai-Thinker RGBW Led Bulb
28 Sonoff T1 1CH   |   x   | Sonoff T1 1-gang Wifi Light Switch
29 Sonoff T1 2CH   |   x   | Sonoff T1 2-gang Wifi Light Switch
30 Sonoff T1 3CH   |   x   | Sonoff T1 3-gang Wifi Light Switch
31 Supla Espablo   |       | 2-gang Wifi Module
32 Witty Cloud     |       | Witty Cloud ESP8266 Wifi Development Board
33 Yunshan Relay   |       | ESP8266 Wifi Network Relay Module
34 MagicHome       |       | MagicHome, Flux-light and some Arilux LC10 RGB(W) Led Controller
35 Luani HVIO      |       | Luani ESP8266 Wifi I/O Module
36 KMC 70011       |       | KMC Wifi Smart Socket with Energy Monitoring
37 Arilux LC01     |       | Arilux AL-LC01 RGB Led Controller
38 Arilux LC11     |       | Arilux AL-LC11 RGBWW Led Controller
39 Sonoff Dual R2  |   x   | Sonoff Dual R2 Wifi Smart Switch
40 Arilux LC06     |       | Arilux AL-LC06 RGB(WW) Led Controller
41 Sonoff S31      |       | Sonoff S31 Wifi Smart Socket with Energy Monitoring
42 Zengge WF017    |       | Zengge WF017 Wifi RGB(W) Led Controller
43 Sonoff Pow R2   |       | Sonoff Pow R2 Wifi Smart Switch with Energy Monitoring
44 Sonoff iFan02   |   x   | Sonoff iFan02 Wifi Smart Ceiling Fan with Light
45 BlitzWolf SHP   |       | BlitzWolf BW-SHP2, BW-SHP6, HomeCube SP1, Gosund SP111, Teckin SP22 Wifi Smart Switch with Energy Monitoring
46 Shelly 1        |       | Shelly 1 Open Source Wifi Relay Module
47 Shelly 2        |       | Shelly 2 Wifi 2-gang Relay Module with Energy Monitoring
48 Xiaomi Philips  |   x   | Xiaomi Philips Wifi WW Led Bulb
49 Neo Coolcam     |       | Neo Coolcam Wifi Smart Socket
50 ESP Switch      |       | ESP Switch 4-gang Wifi Switch with Leds
51 OBI Socket      |       | OBI Wifi Smart Socket
52 Teckin          |       | Teckin SP22 Wifi Smart Switch with Energy Monitoring
53 AplicWDP303075  |       | Aplic WDP 303075 CSL Wifi Smart Switch with Energy Monitoring
54 TuyaMCU         |   x   | Devices with an MCU using Tuya communication protocol for control
55 Gosund SP1 v23  |       | Gosund SP1 v2.3 Wifi Smart Switch with Energy Monitoring
56 ARMTR Dimmer    |   x   | ARMtronix Wifi dimmer for Incandescent Lights and Led
57 SK03 Outdoor    |   x   | SK03 Outdoor Wifi Smart Switch with Energy Monitoring
58 PS-16-DZ        |   x   | PS-16-DZ  Wifi dimmer for Incandescent Lights and Led
59 Teckin US       |       | Teckin SP20 and ZooZee SA102 Wifi Smart Switch with Energy Monitoring
60 Manzoku strip   |       | Manzoku Wifi Smart Power Strip with four Relays
61 OBI Socket 2    |       | OBI 2 Wifi Smart Socket
62 YTF IR Bridge   |   x   | YTF Universal IR Bridge
63 Digoo DG-SP202  |       | Digoo DG-SP202 Dual Wifi Smart Switch with Energy Monitoring
64 KA10            |       | Smanergy KA10 Wifi Smart Wall Switch with Energy Monitoring
65 Luminea ZX2820  |       | Luminea ZX2820 Wifi Smart Switch with Energy Monitoring
66 Mi Desk Lamp    |       | Mi Desk Lamp with rotary switch and Wifi
67 SP10            |       | Tuya SP10 Wifi Smart Switch with Energy Monitoring
68 WAGA CHCZ02MB   |       | WAGA life CHCZ02MB Wifi Smart Switch with Energy Monitoring
69 SYF05           |       | Sunyesmart SYF05 RGBWW Wifi Led Bulb
70 Sonoff L1       |   x   | Sonoff L1 light strip
71 Sonoff iFan03   |   x   | Sonoff iFan03 Wifi Smart Ceiling Fan with Light
72 EXS Dimmer      |   x   | EXS Wifi Dimmer v4
73 PWM Dimmer      |   x   | Martin Jerry/acenx/Tessan/NTONPOWER SD0x PWM Dimmer Switches
74 Sonoff D1       |   x   | Sonoff D1 Wifi and RF Dimmer
75 Sonoff ZbBridge |   x   | Sonoff Zigbee bridge

Over 1600 additional devices are supported using [templates](TEMPLATES.md).
